#!/usr/bin/perl -w
# NAME: cmpicao.pl
# AIM: *** VERY SPECIFIC *** Compare 3 different ICAO list
use strict;
use warnings;
use File::Basename;  # split path ($name,$dir,$ext) = fileparse($file [, qr/\.[^.]*/] )
use Cwd;
use JSON;
use Data::Dumper;
use Time::gmtime;
my $os = $^O;
my $perl_dir = '/home/geoff/bin';
my $PATH_SEP = '/';
my $temp_dir = '/tmp';
if ($os =~ /win/i) {
    $perl_dir = 'C:\GTools\perl';
    $temp_dir = $perl_dir;
    $PATH_SEP = "\\";
}
unshift(@INC, $perl_dir);
require 'lib_utils.pl' or die "Unable to load 'lib_utils.pl' Check paths in \@INC...\n";
# log file stuff
our ($LF);
my $pgmname = $0;
if ($pgmname =~ /(\\|\/)/) {
    my @tmpsp = split(/(\\|\/)/,$pgmname);
    $pgmname = $tmpsp[-1];
}
my $outfile = $temp_dir.$PATH_SEP."temp.$pgmname.txt";
open_log($outfile);

# user variables
my $VERS = "0.0.2 2014-01-13";
my $load_log = 0;
my $in_file = '';
my $verbosity = 0;
my $out_file = '';

# ### DEBUG ###
my $debug_on = 0;
my $def_file = 'def_file';

### program variables
my @warnings = ();
my $cwd = cwd();

sub VERB1() { return $verbosity >= 1; }
sub VERB2() { return $verbosity >= 2; }
sub VERB5() { return $verbosity >= 5; }
sub VERB9() { return $verbosity >= 9; }

sub show_warnings($) {
    my ($val) = @_;
    if (@warnings) {
        prt( "\nGot ".scalar @warnings." WARNINGS...\n" );
        foreach my $itm (@warnings) {
           prt("$itm\n");
        }
        prt("\n");
    } else {
        prt( "\nNo warnings issued.\n\n" ) if (VERB9());
    }
}

sub pgm_exit($$) {
    my ($val,$msg) = @_;
    if (length($msg)) {
        $msg .= "\n" if (!($msg =~ /\n$/));
        prt($msg);
    }
    show_warnings($val);
    close_log($outfile,$load_log);
    exit($val);
}


sub prtw($) {
   my ($tx) = shift;
   $tx =~ s/\n$//;
   prt("$tx\n");
   push(@warnings,$tx);
}

my $in_dir = 'C:\OSGeo4W\apache\htdocs\map-test2\data2';
my $in_json = 'C:\OSGeo4W\apache\htdocs\map-test2\SIDSTAR\all.json';
my $in_csv = 'C:\OSGeo4W\apache\htdocs\map-test2\data2\apt1000-icao.csv';
my %dir_icao = ();  # generated ICAO.json files
my %all_icao = ();  # Pete's navdata all.json
my %csv_icao = ();  # gen'ed CSV

sub process_dir($$);


sub process_in_file_all($) {
    my ($inf) = @_;
    if (! open INF, "<$inf") {
        pgm_exit(1,"ERROR: Unable to open file [$inf]\n"); 
    }
    my @lines = <INF>;
    close INF;
    my $lncnt = scalar @lines;
    prt("Processing $lncnt lines, from [$inf]...\n");
    my ($line,$inc,$lnn);
    $line = join(" ",@lines);
    my $json = JSON->new->allow_nonref;
    my $perl_scalar = $json->decode( $line );

    #$lnn = Dumper($perl_scalar);
    #prt("Dump of perl scalar...\n");
    #prt("$lnn\n");
    #prt("End DUMP\n");
    my $rra = ${$perl_scalar}{rows};
    my $cnt = scalar @{$rra};
    my ($row,$icao,$lat,$lon,$name,$elev);
    prt("Got $cnt rows...\n");
    foreach $row (@{$rra}) {
        $icao = ${$row}{ident};
        $name = ${$row}{name};
        $lat  = ${$row}{lat};
        $lon  = ${$row}{lon};
        $elev = ${$row}{elev_m};
        #push(@all_icao,$icao);
        $all_icao{$icao} = 1;
        #prt("$icao ");
    }
    $cnt = scalar keys %all_icao;
    prt("Got $cnt ICAO entries...\n");
}

# 0    1      2   3   4       5   6
# icao,"name",lat,lon,runways,ils,elev_ft_AMSL
sub process_in_file_csv($) {
    my ($inf) = @_;
    if (! open INF, "<$inf") {
        pgm_exit(1,"ERROR: Unable to open file [$inf]\n"); 
    }
    my @lines = <INF>;
    close INF;
    my $lncnt = scalar @lines;
    prt("Processing $lncnt lines, from [$inf]...\n");
    my ($i,$line,$inc,$lnn,$icao,@arr);
    for ($i = 1; $i < $lncnt; $i++) {
        $line = $lines[$i];
        chomp $line;
        $line = trim_all($line);
        $lnn = length($line);
        next if ($lnn == 0);
        @arr = split(/,/,$line);
        $icao = $arr[0];
        #prt("$icao ");
        #push(@csv_icao,$icao);
        $csv_icao{$icao} = 1;
    }
    $lnn = scalar keys %csv_icao;
    prt("Got $lnn ICAO from $inf\n");


}
sub process_dir($$) {
    my ($dir,$lev) = @_;
    if (!opendir(DIR,$dir)) {
        prtw("WARNING: Failed to open dir $dir!\n");
        return;
    }
    my @files = readdir(DIR);
    closedir(DIR);
    my @dirs = ();
    my ($file,$ff);
    my ($n,$d,$e);
    ut_fix_directory(\$dir);
    prt("Processing dir $dir...\n") if ($lev == 0);
    foreach $file (@files) {
        next if ($file eq '.');
        next if ($file eq '..');
        $ff = $dir.$file;
        if (-d $ff) {
            push(@dirs,$ff);
        } elsif (-f $ff) {
            ($n,$d,$e) = fileparse($ff, qr/\.[^.]*/);
            if ($e =~ /^\.json$/i) {
                #push(@dir_icao,$n);
                $dir_icao{$n} = 1;
            }
        } else {
            pgm_exit(1,"CHECK ME! What is this? [$ff]!\n");
        }
    }
    foreach $ff (@dirs) {
        process_dir($ff,($lev + 1));
    }

}


sub process_in_dir() {
    process_dir($in_dir,0);
    my $cnt = scalar keys %dir_icao;
    prt("Got $cnt ICAO.json files...\n");

}

# Comparing 34074 / 13794 / 27442
sub compare_arrays() {
    my $dir = scalar keys %dir_icao;  # generated ICAO.json files
    my $all = scalar keys %all_icao;  # Pete's navdata all.json
    my $csv = scalar keys %csv_icao;  # gen'ed CSV
    prt("Comparing $dir / $all / $csv\n");
    my ($i,$j,$k,$cnt,$icao,$msg,@arr);
    prt("Processing $dir dir icao\n");
    my %indirnicsv = ();
    my %indirniall = ();
    my %incsvnidir = ();
    my %incsvniall = ();
    my %inallnidir = ();
    my %inallnicsv = ();
    foreach $icao (keys %dir_icao) {
        $msg = '';
        if (!defined $csv_icao{$icao}) {
            $msg .= "$icao NOT in CSV ";
            $indirnicsv{$icao} = 1;
        }
        if (!defined $all_icao{$icao}) {
            $msg .= "$icao NOT in ALL ";
            $indirniall{$icao} = 1;
        }
        if (length($msg)) {
            prt("$msg\n") if (VERB9());
        }
    }
    prt("Processing $csv csv icao\n");
    foreach $icao (keys %csv_icao) {
        $msg = '';
        if (!defined $dir_icao{$icao}) {
            $msg .= "$icao NOT in DIR ";
            $incsvnidir{$icao} = 1;
        }
        if (!defined $all_icao{$icao}) {
            $msg .= "$icao NOT in ALL ";
            $incsvniall{$icao} = 1;
        }
        if (length($msg)) {
            prt("$msg\n") if (VERB9());
        }
    }
    prt("Processing $all all icao\n");
    foreach $icao (keys %all_icao) {
        $msg = '';
        if (!defined $csv_icao{$icao}) {
            $msg .= "$icao NOT in CSV ";
            $inallnicsv{$icao} = 1;
        }
        if (!defined $dir_icao{$icao}) {
            $msg .= "$icao NOT in DIR ";
            $inallnidir{$icao} = 1;
        }
        if (length($msg)) {
            prt("$msg\n") if (VERB9());
        }
    }

    @arr = sort keys %indirnicsv;
    $cnt = scalar @arr;
    prt("\n$cnt indirnicsv ". join(" ",@arr)."\n");

    @arr = sort keys %indirniall;
    $cnt = scalar @arr;
    prt("\n$cnt indirniall ". join(" ",@arr)."\n");

    @arr = sort keys %incsvnidir;
    $cnt = scalar @arr;
    prt("\n$cnt incsvnidir ". join(" ",@arr)."\n");

    @arr = sort keys %incsvniall;
    $cnt = scalar @arr;
    prt("\n$cnt incsvniall ". join(" ",@arr)."\n");

    @arr = sort keys %inallnidir;
    $cnt = scalar @arr;
    prt("\n$cnt inallnidir ". join(" ",@arr)."\n");

    @arr = sort keys %inallnicsv;
    $cnt = scalar @arr;
    prt("\n$cnt inallnicsv ". join(" ",@arr)."\n");

    $msg = "\nSummary: ";
    $cnt = scalar keys %indirnicsv;
    $msg .= "$cnt indirnicsv ";
    $cnt = scalar keys %indirniall;
    $msg .= "$cnt indirniall ";
    $cnt = scalar keys %incsvnidir;
    $msg .= "$cnt incsvnidir ";
    $cnt = scalar keys %incsvniall;
    $msg .= "$cnt incsvniall ";
    $cnt = scalar keys %inallnidir;
    $msg .= "$cnt inallnidir ";
    $cnt = scalar keys %inallnicsv;
    $msg .= "$cnt inallnicsv ";
    prt("$msg\n");
    $load_log = 1;
}

#########################################
### MAIN ###
#parse_args(@ARGV);
process_in_file_csv($in_csv);
process_in_file_all($in_json);
#$load_log = 1;
process_in_dir();
compare_arrays();
pgm_exit(0,"");
########################################

sub need_arg {
    my ($arg,@av) = @_;
    pgm_exit(1,"ERROR: [$arg] must have a following argument!\n") if (!@av);
}

sub parse_args {
    my (@av) = @_;
    my ($arg,$sarg);
    my $verb = VERB2();
    while (@av) {
        $arg = $av[0];
        if ($arg =~ /^-/) {
            $sarg = substr($arg,1);
            $sarg = substr($sarg,1) while ($sarg =~ /^-/);
            if (($sarg =~ /^h/i)||($sarg eq '?')) {
                give_help();
                pgm_exit(0,"Help exit(0)");
            } elsif ($sarg =~ /^v/) {
                if ($sarg =~ /^v.*(\d+)$/) {
                    $verbosity = $1;
                } else {
                    while ($sarg =~ /^v/) {
                        $verbosity++;
                        $sarg = substr($sarg,1);
                    }
                }
                $verb = VERB2();
                prt("Verbosity = $verbosity\n") if ($verb);
            } elsif ($sarg =~ /^l/) {
                if ($sarg =~ /^ll/) {
                    $load_log = 2;
                } else {
                    $load_log = 1;
                }
                prt("Set to load log at end. ($load_log)\n") if ($verb);
            } elsif ($sarg =~ /^o/) {
                need_arg(@av);
                shift @av;
                $sarg = $av[0];
                $out_file = $sarg;
                prt("Set out file to [$out_file].\n") if ($verb);
            } else {
                pgm_exit(1,"ERROR: Invalid argument [$arg]! Try -?\n");
            }
        } else {
            $in_file = $arg;
            prt("Set input to [$in_file]\n") if ($verb);
        }
        shift @av;
    }

    if ($debug_on) {
        prtw("WARNING: DEBUG is ON!\n");
        if (length($in_file) ==  0) {
            $in_file = $def_file;
            prt("Set DEFAULT input to [$in_file]\n");
        }
    }
    if (length($in_file) ==  0) {
        pgm_exit(1,"ERROR: No input files found in command!\n");
    }
    if (! -f $in_file) {
        pgm_exit(1,"ERROR: Unable to find in file [$in_file]! Check name, location...\n");
    }
}

sub give_help {
    prt("$pgmname: version $VERS\n");
    prt("Usage: $pgmname [options] in-file\n");
    prt("Options:\n");
    prt(" --help  (-h or -?) = This help, and exit 0.\n");
    prt(" --verb[n]     (-v) = Bump [or set] verbosity. def=$verbosity\n");
    prt(" --load        (-l) = Load LOG at end. ($outfile)\n");
    prt(" --out <file>  (-o) = Write output to this file.\n");
}

# eof - template.pl
